import {iTenderStatus} from "./iTenderStatus";
import Container from "./database/Container";
import {HCSR04} from "hc-sr04";
import {IContainer} from "./database/IContainer";
import Drink from "./database/Drink";
import {IDrink} from "./database/IDrink";

export class iTender {
    private static _status: iTenderStatus;

    private static containers: { container: IContainer, sensor: HCSR04, pump: null }[];
    private static drinks: IDrink[];

    static set status(value: iTenderStatus) {
        this._status = value;
    }

    static get status(): iTenderStatus {
        return this._status;
    }

    static startFill() {
        // todo Fill method
    }

    static stopFill() {
        // todo Stop fill method
    }

    static measureContainers(): Promise<void> {
        return new Promise(async resolve => {
            let containers = await Container.find();
            /*
            public measure() : Number {
        let dist = this.sensor.distance();
        return dist * 100 / (this.sensorFilledMax + this.sensorFilledMin);
    }
             */
        })
    }

    static refreshDrinks(): Promise<void> {
        return new Promise(async resolve => {
            this.drinks = [];
            for (let d of (await Drink.find().populate("ingredients.type"))) {


                let drinkAccept = true;

                for (let i of d.ingredients) {
                    let c = await Container.findOne({content: i["type"]});

                    if (!c) {
                        drinkAccept = false;
                        break;
                    }

                }
                if (drinkAccept)
                    this.drinks.push(d);
            }
        });
    }

    static refreshContainers(): Promise<void> {

        return new Promise(async resolve => {
            let containers = await Container.find();
            for (let c of containers) {
                let i = 0;
                let found = false;
                for (let c2 of this.containers) {
                    if (c2.container._id == c._id) {
                        this.containers[i] = {
                            container: c,
                            sensor: new HCSR04(c.sensorTrigger, c.sensorEcho),
                            pump: null
                        };
                        found = true;
                        break;
                    }
                    i++;
                }
                if (!found)
                    this.containers.push({container: c, sensor: new HCSR04(c.sensorTrigger, c.sensorEcho), pump: null});
            }
        })
    }


}