import {App} from "./App";
import debug from "debug";
import {WebsocketApp} from "./WebsocketApp";
import {Database} from "./database/Database";
import Drink from "./database/Drink";
import Ingredient from "./database/Ingredient";
import Container from "./database/Container";
import {iTender} from "./iTender";

const log = debug("itender:server");

const app = new App();
const wsApp = new WebsocketApp();


(async () => {
    try {
        log("Starting...");
        await Database.connect();
        await app.listen();
        await wsApp.listen();
        await init();
    } catch (e) {
        console.error("---- ERROR ----")
        console.error(e);
        process.exit(-1);
    }
})();

function init() : Promise<void> {
    log("Initializing...");
    return new Promise(async resolve => {
        await iTender.refreshContainers();
        await iTender.refreshDrinks();
        resolve();
    });
}

async function test() {
    console.log("Testing fn");

    let ingredient = await Ingredient.findOne({name: "Cola"});
    if (!ingredient)
        return;

    /*let drink = new Drink();
    drink.name = "Cola";
    drink.ingredients = [{type: ingredient, amount: 200}];

    await drink.save();*/

    let drink = await Drink.findOne({name: "Cola"}).populate("ingredients.type");
    if (!drink) return;

    console.log(drink);

    /*let container = new Container();
    container.slot = 1;
    container.volume = 750;
    container.sensorEcho = 26;
    container.sensorTrigger = 27;
    container.content = ingredient;
    container.sensorFilledMax = 2;
    container.sensorFilledMin = 15;

    await container.save();*/

    let container = await Container.findOne({slot: 1});
    if (!container) return;

    console.log(container);


    //console.log(drink.ingredients)
    /*let ingredient = new Ingredient();
    ingredient.name = "Cola";
    ingredient.category = Category.ALCOHOL_FREE;

    await ingredient.save();

    let ingredient2 = new Ingredient();
    ingredient2.name = "Fanta";
    ingredient2.category = Category.ALCOHOL_FREE;

    await ingredient2.save();

    let drink = new Drink();
    drink.name = "Mezzo Mix";
    drink.ingredients = [ {type: ingredient2, amount: 2}, { type: ingredient, amount: 10 } ];

    await drink.save();*/


}